/**************************
 * Includes
 *
 **************************/

#include "glut.h"
#include "vec.h"

//timing
typedef struct
{
	int framecount;
	int	time;
	int lasttime;
	int frametime;

}timer_t;
timer_t timer;

#ifdef WIN32
#define	MAX_FPS 90
#else
#define MAX_FPS 100
#endif


//--- 3d cam
#define	PITCH				0		// up / down
#define	YAW					1		// left / right
#define	ROLL				2		// fall over
typedef struct
{
	int		flyMode;

	//flymode
    vec3_t	origin;
    vec3_t	angles;

	//rotation mode
	float	eye[3];
	float	rot[3];

} cam_t;
cam_t cam;
//---- 3d cam


//-COLOR handlers-
enum {
    RED,
    GREEN,
    BLUE,
    RGB
};

//scale the world
extern float worldScale;


//----------- Objects

enum {
    MODEL_NONE,
    MODEL_MAYAOBJ,
    MODEL_JSM,
    
    MODEL_TYPES
};


//---------------------------------------------------------
//	OBJECTS (origin, angles, model)
//---------------------------------------------------------

typedef struct object_s
{
	vec3_t	origin;
	vec3_t	angles;
	vec3_t	scale;

	//int		frame;	//someday

	int		modelType;
	
	struct _GLMmodel	*OBJmodel;		//if it's a maya obj model
    
} object_t;

#define		MAX_OBJECTS 1024
object_t	sceneObjects[MAX_OBJECTS];
int			sceneNumObjects;

//---------------------------------------------------------



//---------------------------------------------------------

void Init_3dObjects(void);
void Init_GLCam(void);
void drawString(char *str, void *font, GLclampf r, GLclampf g, GLclampf b, GLfloat x, GLfloat y);
int GL_AddLineToScene(vec3_t origin, vec3_t origin2, vec3_t color);
int GL_AddCubeToSceneAtLoc(vec3_t origin, vec3_t color, vec3_t angles, float scale);


//---------------------
//Cammera Movements
//---------------------

//fly mode
void CamMoveUp(float value);
void CamMoveDown(float value);
void CamMoveFwrd(float value);
void CamMoveBack(float value);
void CamMoveLeft(float value);
void CamMoveRight(float value);
void CamRotateYaw(float x);
void CamRotatePitch(float y);
// rotation mode
void CamRotateScreen(float x, float y);
void CamTranslateZ(float value);
void CamTranslateXY(float x, float y);

//-------------------------------------------------------------
// DrawGLScene
//-------------------------------------------------------------
void DrawGLScene(void);

//-------------------------------------------------------------
// Console, and formated text print
//-------------------------------------------------------------
void DrawFormattedText(char *header, char *text, float x, float y, BOOL drawCursor);
void Input( const char *msg, char *inputPoint, int max_len);
void InputAction( const char *msg, char *inputPoint, int max_len, void (*action)(void));
void SCRPrint (float x, float y, char *fmt, ...);
int InputStringKey(unsigned char key);


//--------------------------------------
//	SKM model
//--------------------------------------
int SKM_BoneKeysAction(int key);
void BoneSelectNext(int value);



