/***********************************************
*
*
*
************************************************
*
* Glut Version: 3.7
*
* Very special thanks to all people who
* contributed with any online tutors or
* help files. Keep coding!
*
***********************************************/
#include <windows.h>
#include "glut.h"
#include "glui.h"
#include <stdio.h>

//-----------------------------------------------
int		main_window;
//-----------------------------------------------

int		segments = 8;

extern "C" 
{
	int wireframe;


	void KEYS_InitializeKeyStates(void);
	void KEYS_CheckKeyStates(void);
	void KEYS_PressKey(unsigned char key, int x, int y);
	void KEYS_ReleaseKey(unsigned char key, int x, int y);
	void KEYS_PressSpecialKey(int value, int x, int y);
	void KEYS_ReleaseSpecialKey(int value, int x, int y);
	void MOUSE_Motion(int x, int y);
	void MOUSE_Button(int button, int state, int x, int y);

	//gl_scene.c
	void Scene_Main( void );
	void InitializeWorld (void);
	void CAM_ToogleFlyMode(void);
	void DISPLAY_ToogleShowFPS(void);
	void DISPLAY_ToogleWireframe(void);
	void DISPLAY_ToogleQuats(void);
	void InitializeOGL(void);

	//void FPScalculator( int time, int framecount);

	//skm_model.c
	void BoneSelectNext( int value );
	void MeshSelectNext(int value);
	void BoneToogleAttachFlag(void);
	void ChangeBoneName( void );
	void SKM_SaveSkeleton(void);
	void SKM_SaveModel(void);
	void SKM_RotateSkeleton(void);
	void SKM_Rotate(float angles[3]);

	void Change_SelectedBoneName( char *newname );
	void Change_SelectedMeshName( char *newname );
	void Change_SelectedSkinMeshName( char *newname );

	char *getSelectedBoneName(void);
	char *getSelectedMeshName(void);
	char *getSelectedSkinMeshName(void);

	//boneKeys
	struct mskbonekeys_s *SKM_GetBoneKeys(void);


	//tmp
	void SCRPrint (float x, float y, char *fmt, ...);
}

//-----------------------------------------------


//#define LOADMENU		//uncomment for loading menu
#ifdef LOADMENU
#include "dirent32.h"
#define LOADMENU_DATA_DIR "data/"			//search into this directory
#define LOADMENU_EXTENSION ".plk"	//files with this extension
#endif //LOADMENU


/* windows size and position constants */
const int GL_WIN_WIDTH = 640;
const int GL_WIN_HEIGHT = 480;
const int GL_WIN_INITIAL_X = 0;
const int GL_WIN_INITIAL_Y = 0;

int	is_fullscreen;

//-----------------------------

void GLUI_CMDLINE_UpdateBoneName(void);

void GLUI_SelectNextBone (void)
{
	BoneSelectNext(1);
	GLUI_CMDLINE_UpdateBoneName();
}

void GLUI_SelectPrevBone (void)
{
	BoneSelectNext(-1);
	GLUI_CMDLINE_UpdateBoneName();
}

void GLUI_CMDLINE_UpdateMeshName(void);

void GLUI_SelectNextMesh (void)
{
	MeshSelectNext(1);
	GLUI_CMDLINE_UpdateMeshName();
}

void GLUI_SelectPrevMesh (void)
{
	MeshSelectNext(-1);
	GLUI_CMDLINE_UpdateMeshName();
}


//-----------------------------
//
// Loading Submenu
//
//-----------------------------
#ifdef LOADMENU
GLint      entries = 0;
void loadmenu(int item)
{
    int i = 0;
    DIR* dirp;
    char* name;
    struct dirent* direntp;
	
    if (item >= 0) {
		//keyboard((unsigned char)item, 0, 0);
    } else {
		dirp = opendir(LOADMENU_DATA_DIR);
		while ((direntp = readdir(dirp)) != NULL) {
			if (strstr(direntp->d_name, LOADMENU_EXTENSION)) {
				i++;
				if (i == -item)
					break;
			}
		}
		if (!direntp)
			return;
		name = (char*)malloc(strlen(direntp->d_name) + strlen(LOADMENU_DATA_DIR) + 1);
		strcpy(name, LOADMENU_DATA_DIR);
		strcat(name, direntp->d_name);
		
		//call loading func
		//AI_LoadPLinksFile(direntp->d_name);
		
		free(name);
		
		glutPostRedisplay();
    }
}
#endif //LOADMENU

//-------------------------
// Returns true if x,y is inside GLUI viewport
//-------------------------
BOOL GLUI_CursorInsideView(int x, int y)
{
	int tx, ty, tw, th;

	GLUI_Master.get_viewport_area( &tx, &ty, &tw, &th );
	printf("%i - %i\n", y, ty);
	if( (x > tx && x < tx+tw) && (y > 0 && y < th) )
		return TRUE;

	return FALSE;
}


//-----------------------------
//
//	KEYS
//
//-----------------------------
void InitializeKeyStates(void)
{
	KEYS_InitializeKeyStates();
}

//-------------------------
// keyboard inputs (make them act when pressed)
//-------------------------
void CheckKeyStates(void)
{
	KEYS_CheckKeyStates();
}

//-------------------------
// keyboard inputs (press)
//-------------------------
void glutKeyboard(unsigned char key, int x, int y)
{
	if(!GLUI_CursorInsideView(x, y) )
		return;

	KEYS_PressKey( key, x, y );
}

//--------------------------
// keyboard inputs (release)
//--------------------------
void glutKeyboardUp(unsigned char key, int x, int y)
{
	if(!GLUI_CursorInsideView(x, y) )
		return;

	KEYS_ReleaseKey( key, x, y);
}

//---------------------------
// special keyboard inputs (press) (SHIFT, CTRL, ALT)
//---------------------------
void glutSpecial(int value, int x, int y)
{
	if(!GLUI_CursorInsideView(x, y) )
		return;

	switch (value)
	{
		case GLUT_KEY_RIGHT:
			GLUI_SelectNextBone();
			break;
		case GLUT_KEY_LEFT:
			GLUI_SelectPrevBone();
			break;
	}

	KEYS_PressSpecialKey( value, x, y);
}

//---------------------------
// special keyboard inputs (release) (SHIFT, CTRL, ALT)
//---------------------------
void glutSpecialUp(int value, int x, int y)
{
	if(!GLUI_CursorInsideView(x, y) )
		return;

	KEYS_ReleaseSpecialKey( value, x, y );
}

//----------------------------
// Moves the screen based on mouse
//----------------------------
void glutMotion(int x, int y)
{
	MOUSE_Motion( x, y);
}

//-----------------------------
// Function that handles mouse buttons input
//-----------------------------
void glutMouse(int button, int state, int x, int y)
{
	MOUSE_Button( button, state, x, y );
}


void displaySubMenu(int value)
{
	switch (value)
	{
		case 1:
			DISPLAY_ToogleShowFPS();
			break;
		case 2:
			DISPLAY_ToogleWireframe();
			break;
		case 3:
			if (glIsEnabled(GL_CULL_FACE))
				glDisable(GL_CULL_FACE);
			else
				glEnable(GL_CULL_FACE);
			break;
		case 4:
			//enter/leave fullscreen
			if (is_fullscreen) {
				glutReshapeWindow(GL_WIN_WIDTH, GL_WIN_HEIGHT);
				is_fullscreen = FALSE;
			} else {
				glutFullScreen();
				is_fullscreen = TRUE;
			}
			break;
		case 5:
			CAM_ToogleFlyMode();
			break;

		case 6:
			DISPLAY_ToogleQuats();
			break;
			
	}
	glutPostRedisplay();
}
//------------------------------------------------------------------------
// The glut's menu callback function. Called every time an option is selected
//------------------------------------------------------------------------
void glutMenu(int value)
{
	switch (value)
	{
		//glutAddMenuEntry("Bone: Select Next", 1);
//		case 1:
//			GLUI_SelectNextBone();
//			break;
		//glutAddMenuEntry("Bone: Select Prev", 2);
//		case 2:
//			GLUI_SelectPrevBone();
//			break;
		//glutAddMenuEntry("Bone: Toogle Upper", 3);
//		case 3:
//			BoneToogleAttachFlag();
//			break;
		//glutAddMenuEntry("ImputString", 4);
//		case 4:
//			ChangeBoneName();
//			break;

		case 5:
		//glutAddMenuEntry("Model: Save SKP file", 5);
			SKM_SaveSkeleton();
			break;

		case 6:
		//glutAddMenuEntry("Model: Save SKM file", 6);
			SKM_SaveModel();
			break;

//		case 7:
		//glutAddMenuEntry("Model: Rotate Skeleton", 7);
//			SKM_RotateSkeleton();
//			break;

		case 255:
			exit(0);
			break;
	}
	glutPostRedisplay();
}





void myGLutResize(int width, int height)
{
	if (height<=0)	//prevent divide by 0
		height=1;

	glViewport(0, 0, width, height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,65536);//65536<-QFusion
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glutPostRedisplay();
}




//=============================================================
//==================		 PANELS			===================
//=============================================================


typedef struct
{
	GLUI	*glui;

	int		visible;
	int		enabled;

	char	name[256];

	void	(*reshape)(void);

}panel_handle_t;
panel_handle_t	bottomBar;

void GLUI_Resize(int width, int height);
void GLUI_RefreshPanels (void)
{
	GLUI_Resize(glutGet(GLUT_WINDOW_WIDTH), glutGet(GLUT_WINDOW_HEIGHT));
}

//--------------------GENERIC PANEL
char *string_list[] = { "Bone", "Mesh", "Rotate" /*, "Anim"*/ };
#define NUMBER_OF_PANELS  3
int   curr_string = 0;
#define	LISTBOX_GENERICPANEL_ID		300

GLUI_Listbox *list;
//--------------------------------
void UpdateSharedBarPanel(char *newpanel_name);
void generic_callback( int control )
{
	if ( control == LISTBOX_GENERICPANEL_ID ) {
		int i;
		for(i=0;i<NUMBER_OF_PANELS;i++)
			if ( !strcmp( string_list[curr_string], string_list[i]) )
				UpdateSharedBarPanel(string_list[curr_string]);
	}
}

void GLUI_InitGenericPanel(void)
{

	//GLUI *glui = GLUI_Master.create_glui( "Options", 0, GL_WIN_INITIAL_X + GL_WIN_WIDTH + 12, GL_WIN_INITIAL_Y ); // name, flags, x, and y
	GLUI *glui = GLUI_Master.create_glui_subwindow( main_window, GLUI_SUBWINDOW_BOTTOM );//GLUI_SUBWINDOW_BOTTOM //GLUI_SUBWINDOW_RIGHT 
	glui->set_main_gfx_window( main_window );


	/**** Add listbox ****/
	//-------------------------------------------
	int i;
	GLUI_Listbox *list = glui->add_listbox( "panel:", &curr_string, LISTBOX_GENERICPANEL_ID, generic_callback );
	for( i=0; i<NUMBER_OF_PANELS; i++ )
		list->add_item( i, string_list[i] );
	//-------------------------------------------
	glui->add_column();

}




//-------------BONE PANEL
GLUI			*animPanel;

#define MAX_BONES 128
//char *key_strings[] = { "ALL", "B", "U" };
int   curr_key_string = 0;

//animations window
int	anim_window;
#define LISTBOX_ANIMKEYS_ID 150

typedef struct mskbonekeys_s
{
	int				numbonekeys;
	int				*keys;
	int				*frames;

} mskbonekeys_t;

//callback IDs
//--------------
/*

void animpanel_callback( int control )
{
	if( control == LISTBOX_ANIMKEYS_ID )
	{

	}
}
void animpanel_reshape(void)
{
}

void GLUI_InitAnimPanel( void )
{
	mskbonekeys_t	*boneKeys;


	animPanel = GLUI_Master.create_glui_subwindow( main_window, GLUI_SUBWINDOW_BOTTOM );
	animPanel->set_main_gfx_window( main_window );

	GLUI_Panel *anim_select_subpanel = animPanel->add_panel( "AnimSelect", GLUI_PANEL_RAISED );
	//--Add listbox------------------------------
	int i;
	GLUI_Listbox *keylist = animPanel->add_listbox_to_panel( anim_select_subpanel, "key:", &curr_key_string, LISTBOX_ANIMKEYS_ID, animpanel_callback );
	//get boneKeys
	boneKeys = SKM_GetBoneKeys();
	//generate key_strings
	for( i=0; i<boneKeys->numbonekeys; i++) {
		char	s[2];
		s[0] = boneKeys->keys[i];s[1]=0;
		keylist->add_item( i, s );
	}
	keylist->add_item( boneKeys->numbonekeys, "All" );
	//-------------------------------------------


	
	GLUI_Panel *anim_play_subpanel = animPanel->add_panel( "Anim", GLUI_PANEL_RAISED );
	animPanel->add_column_to_panel(anim_play_subpanel);
	animPanel->add_button_to_panel( anim_play_subpanel, "Play", 0, animpanel_callback );
	animPanel->add_column_to_panel(anim_play_subpanel);
	animPanel->add_button_to_panel( anim_play_subpanel, "Stop", 0, animpanel_callback );

	bottomBar.glui = animPanel;
	bottomBar.visible = TRUE;
	bottomBar.reshape = animpanel_reshape;
	strncpy(bottomBar.name, "Anim", sizeof(bottomBar.name));
}

*/



//-------------Rotate Panel
GLUI *rotatePanel;
GLUI_Spinner *rotyaw_spinner;
GLUI_Spinner *rotpitch_spinner;
GLUI_Spinner *rotroll_spinner;

float	rotangles[3];
#define BUTTON_ROTATE_ID		200

#define	PITCH				0		// up / down
#define	YAW					1		// left / right
#define	ROLL				2		// fall over
//-------------
void rotatepanel_callback( int control )
{
	if ( control == BUTTON_ROTATE_ID ) {
		SKM_Rotate(rotangles);
	}
}
void rotatepanel_reshape(void)
{
}
void GLUI_InitRotatePanel(void)
{
	rotatePanel = GLUI_Master.create_glui_subwindow( main_window, GLUI_SUBWINDOW_BOTTOM );
	rotatePanel->set_main_gfx_window( main_window );


	//rotatePanel->add_column();

	//rotate panel

	//YAW spinner
	rotyaw_spinner = rotatePanel->add_spinner( "Yaw:", GLUI_SPINNER_FLOAT, &rotangles[YAW] );
	rotyaw_spinner->set_int_limits( -360, 360 );
	//PITCH spinner
	rotatePanel->add_column();
	rotpitch_spinner = rotatePanel->add_spinner( "Pitch:", GLUI_SPINNER_FLOAT, &rotangles[PITCH] );
	rotpitch_spinner->set_int_limits( -360, 360 );
	//ROLL spinner
	rotatePanel->add_column();
	rotroll_spinner = rotatePanel->add_spinner( "Roll:", GLUI_SPINNER_FLOAT, &rotangles[ROLL] );
	rotroll_spinner->set_int_limits( -360, 360 );
	//Rotate Button
	rotatePanel->add_column();
	rotatePanel->add_button( "Rotate", BUTTON_ROTATE_ID, rotatepanel_callback );

	//rotatePanel->add_separator();
	//rotatePanel->add_button( "Quit", 0,(GLUI_Update_CB)exit );

	bottomBar.glui = rotatePanel;
	bottomBar.visible = TRUE;
	bottomBar.reshape = rotatepanel_reshape;
	strncpy(bottomBar.name, "Rotate", sizeof(bottomBar.name));
}

//-------------BONE PANEL
GLUI			*bonePanel;
int				show_bonepanel;

GLUI_EditText   *boneNameEditText;
int				bone_edittext_enabled;

//callback IDs
#define EDITTEXT_BONENAME_ID			100
#define CHECKBOX_RENAMEBONE_ID			102
//--------------
void bonepanel_callback( int control )
{
	if ( control == EDITTEXT_BONENAME_ID && bone_edittext_enabled == TRUE ) 
	{
		//printf( "Command: %s\n", boneNameEditText->get_text() );
		Change_SelectedBoneName( boneNameEditText->get_text() );//update into model
	}
	if ( control == CHECKBOX_RENAMEBONE_ID ) 
	{
		if(bone_edittext_enabled == FALSE)
			boneNameEditText->disable();
		else
			boneNameEditText->enable();
	}
}
void bonepanel_reshape(void)
{
	boneNameEditText->set_w(256);
	boneNameEditText->set_h(GLUI_EDITTEXT_HEIGHT);
}
void GLUI_CMDLINE_UpdateBoneName(void)
{
	boneNameEditText->set_text( getSelectedBoneName() );
}

void GLUI_InitBonePanel( void )
{
	bonePanel = GLUI_Master.create_glui_subwindow( main_window, GLUI_SUBWINDOW_BOTTOM );
	bonePanel->set_main_gfx_window( main_window );
	
	//bonePanel->add_column();

	GLUI_Panel *bone_rename_subpanel = bonePanel->add_panel( "Bone", GLUI_PANEL_RAISED );

	boneNameEditText = bonePanel->add_edittext_to_panel( bone_rename_subpanel, "bone:", GLUI_EDITTEXT_TEXT, NULL, EDITTEXT_BONENAME_ID, bonepanel_callback );
	boneNameEditText->set_font(GLUT_BITMAP_HELVETICA_10);
	boneNameEditText->set_text( getSelectedBoneName() );
	
	bonePanel->add_column_to_panel(bone_rename_subpanel);
	bone_edittext_enabled = FALSE;
	GLUI_Checkbox *cmdline_enable_checkbox = bonePanel->add_checkbox_to_panel( bone_rename_subpanel, "Rename", &bone_edittext_enabled, CHECKBOX_RENAMEBONE_ID, bonepanel_callback );
	cmdline_enable_checkbox->set_font(GLUT_BITMAP_HELVETICA_10);
	boneNameEditText->disable();
	
	bonePanel->add_column_to_panel(bone_rename_subpanel);
	bonePanel->add_button_to_panel( bone_rename_subpanel, "Prev", 0, (GLUI_Update_CB)GLUI_SelectPrevBone );
	bonePanel->add_column_to_panel(bone_rename_subpanel);
	bonePanel->add_button_to_panel( bone_rename_subpanel, "Next", 0, (GLUI_Update_CB)GLUI_SelectNextBone );

	//bonePanel->add_separator();
	//bonePanel->add_button( "Quit", 0,(GLUI_Update_CB)exit );

	if(!show_bonepanel)
		bonePanel->hide();

	bottomBar.glui = bonePanel;
	bottomBar.visible = show_bonepanel;
	bottomBar.reshape = bonepanel_reshape;
	strncpy(bottomBar.name, "Bone", sizeof(bottomBar.name));
}



//-------------MESH PANEL
GLUI			*meshPanel;
int				show_meshpanel;

GLUI_EditText   *meshNameEditText;
GLUI_EditText   *meshSkinNameEditText;
int				mesh_edittext_enabled;
int				mesh_skintext_enabled;

//callback IDs
#define EDITTEXT_MESHNAME_ID			110
#define EDITTEXT_MESHSKINNAME_ID		111
#define CHECKBOX_MESHPANEL_ID			112
#define CHECKBOX_RENAMEMESH_ID			113
#define	CHECKBOX_RENAMEMESHSKIN_ID		114

//--------------
void meshpanel_callback( int control )
{
	if ( control == EDITTEXT_MESHNAME_ID && mesh_edittext_enabled == TRUE ) 
	{
		//printf( "MESH panel: %s\n", meshNameEditText->get_text() );
		Change_SelectedMeshName( meshNameEditText->get_text() );//update into model
	}
	if ( control == CHECKBOX_RENAMEMESH_ID ) 
	{
		if(mesh_edittext_enabled == FALSE)
			meshNameEditText->disable();
		else
			meshNameEditText->enable();
	}
	if ( control == CHECKBOX_RENAMEMESHSKIN_ID )
	{
		if(mesh_skintext_enabled == FALSE)
			meshSkinNameEditText->disable();
		else
			meshSkinNameEditText->enable();
	}
	if (control == EDITTEXT_MESHSKINNAME_ID )
	{
		//printf( "MESH SKIN: %s\n", meshSkinNameEditText->get_text() );
		Change_SelectedSkinMeshName( meshSkinNameEditText->get_text() );//update into model
	}
}

void meshpanel_reshape(void)
{
	meshNameEditText->set_w(256);
	meshNameEditText->set_h(GLUI_EDITTEXT_HEIGHT);
	//skin subpanel
	meshSkinNameEditText->set_w(256);
	meshSkinNameEditText->set_h(GLUI_EDITTEXT_HEIGHT);
}

void GLUI_CMDLINE_UpdateMeshName(void)
{
	meshNameEditText->set_text( getSelectedMeshName() );
}

void GLUI_InitMeshPanel( void )
{
	meshPanel = GLUI_Master.create_glui_subwindow( main_window, GLUI_SUBWINDOW_BOTTOM );
	meshPanel->set_main_gfx_window( main_window );
	

	//------------------------------------------

	GLUI_Panel *mesh_rename_subpanel = meshPanel->add_panel( "meshpanel", GLUI_PANEL_RAISED );
	mesh_rename_subpanel->set_alignment(GLUI_ALIGN_LEFT);
	

	meshNameEditText = meshPanel->add_edittext_to_panel( mesh_rename_subpanel, "mesh:", GLUI_EDITTEXT_TEXT, NULL, EDITTEXT_MESHNAME_ID, meshpanel_callback );
	meshNameEditText->set_font(GLUT_BITMAP_HELVETICA_10);
	meshNameEditText->set_text( getSelectedMeshName() );
	meshNameEditText->set_alignment(GLUI_ALIGN_LEFT);
	
	meshPanel->add_column_to_panel(mesh_rename_subpanel);
	mesh_edittext_enabled = FALSE;
	GLUI_Checkbox *meshrename_enable_checkbox = meshPanel->add_checkbox_to_panel( mesh_rename_subpanel, "Rename", &mesh_edittext_enabled, CHECKBOX_RENAMEMESH_ID, meshpanel_callback );
	meshrename_enable_checkbox->set_font(GLUT_BITMAP_HELVETICA_10);
	meshNameEditText->disable();
	
	meshPanel->add_column_to_panel(mesh_rename_subpanel);
	meshPanel->add_button_to_panel(mesh_rename_subpanel, "Prev", 0, (GLUI_Update_CB)GLUI_SelectPrevMesh );
	meshPanel->add_column_to_panel(mesh_rename_subpanel);
	meshPanel->add_button_to_panel(mesh_rename_subpanel, "Next", 0, (GLUI_Update_CB)GLUI_SelectNextMesh );

	//-----------------------------------------

	//skin subpanel
	GLUI_Panel *mesh_skin_subpanel = meshPanel->add_panel( "skin", GLUI_PANEL_RAISED );
	mesh_skin_subpanel->set_alignment(GLUI_ALIGN_LEFT);

	meshSkinNameEditText = meshPanel->add_edittext_to_panel( mesh_skin_subpanel, "skin:", GLUI_EDITTEXT_TEXT, NULL, EDITTEXT_MESHSKINNAME_ID, meshpanel_callback );
	meshSkinNameEditText->set_font(GLUT_BITMAP_HELVETICA_10);
	//meshSkinNameEditText->set_text("not yet");//set_text( getSelectedSkinMeshName() );
	meshSkinNameEditText->set_text( getSelectedSkinMeshName() );
	meshSkinNameEditText->set_alignment(GLUI_ALIGN_LEFT);
	
	meshPanel->add_column_to_panel(mesh_skin_subpanel);
	mesh_skintext_enabled = FALSE;
	GLUI_Checkbox *skinmesh_rename_enable_checkbox = meshPanel->add_checkbox_to_panel( mesh_skin_subpanel, "Rename", &mesh_skintext_enabled, CHECKBOX_RENAMEMESHSKIN_ID, meshpanel_callback );
	skinmesh_rename_enable_checkbox->set_font(GLUT_BITMAP_HELVETICA_10);
	meshSkinNameEditText->disable();

	
	if(!show_meshpanel)
		meshPanel->hide();

	bottomBar.glui = meshPanel;
	bottomBar.visible = show_meshpanel;
	bottomBar.reshape = meshpanel_reshape;
	strncpy(bottomBar.name, "Mesh", sizeof(bottomBar.name));
	
}


//--------------------Shared Bar
void UpdateSharedBarPanel(char *newpanel_name)
{
	if(!strcmp(bottomBar.name, newpanel_name) )
		return;

	if(!strcmp( newpanel_name, "Bone" ) ){
		if(bottomBar.glui)
			bottomBar.glui->close();
		GLUI_InitBonePanel();
	}
	else if(!strcmp( newpanel_name, "Mesh" ) ){
		if(bottomBar.glui)
			bottomBar.glui->close();
		GLUI_InitMeshPanel();
	}
	else if(!strcmp( newpanel_name, "Rotate" ) ){
		if(bottomBar.glui)
			bottomBar.glui->close();
		GLUI_InitRotatePanel();
	}
/*
	else if(!strcmp( newpanel_name, "Anim" ) ){
		if(bottomBar.glui)
			bottomBar.glui->close();
		GLUI_InitAnimPanel();
	}
*/
}

//------------------------------



//------------------------------------------------------------------------
// Window resize function
//------------------------------------------------------------------------
void GLUI_Resize(int width, int height)
{
	if (height==0)	//prevent divide by 0
		height=1;

	if(bottomBar.visible)
		bottomBar.glui->hide();

	/* GLUI */
	int tx, ty, tw, th;
	GLUI_Master.get_viewport_area( &tx, &ty, &tw, &th );

	//glutResize( tw, th );

	glViewport( tx, ty, tw, th );
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0f,(GLfloat)tw/(GLfloat)th,0.1f,65536);//65536<-QFusion
	//gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,65536);//65536<-QFusion
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glutPostRedisplay();

	if(bottomBar.visible){
		bottomBar.reshape();
		bottomBar.glui->show();
	}
}




//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
//vvvvvvvvvvvvvvvvvvvvvv ATTENTION HERE!!! vvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
//************************************************************************
// The draw function. Replaces code listed here for your own drawing code.
// For demo of the framework i drawed i simple cube that can be freely
// rotated with mouse buttons.
//************************************************************************
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
void glutDisplay(void)
{
}
void GLUI_Idle( void )
{
	//According to the GLUT specification, the current window is 
	//undefined during an idle callback.  So we need to explicitly change
	//it if necessary 
	if ( glutGetWindow() != main_window ) 
		glutSetWindow(main_window);

	//world frame: draw scene if needed
	Scene_Main();
}

//------------------------------------------------------------------------
//   It's the main application function. Note the clean code you can
//   obtain using he GLUT library. No calls to dark windows API
//   functions with many obscure parameters list. =)
//------------------------------------------------------------------------
int main(int argc, char** argv)
{
	int submenu;
	//int	window;

#ifdef LOADMENU
	struct dirent* direntp;
    DIR* dirp;
    int submenu_load;
#endif //LOADMENU

#ifdef WIN32
	timeBeginPeriod( 1 );
#endif

    /*
        Glut's initialization code. Set window's size and type of display.
        Window size is put half the 800x600 resolution as defined by above
	constants. The windows is positioned at the top leftmost area of
	the screen.
    */
    glutInitDisplayMode( GLUT_DOUBLE | GLUT_DEPTH | GLUT_RGBA | GLUT_MULTISAMPLE );
    glutInitWindowPosition( GL_WIN_INITIAL_X, GL_WIN_INITIAL_Y );
    glutInitWindowSize( GL_WIN_WIDTH, GL_WIN_HEIGHT );
    glutInit( &argc, argv );

	main_window = glutCreateWindow("skmtool");
	if(!main_window)
		exit(0);

	glutIgnoreKeyRepeat(1);	//we're going to set key (up/down) state manually
	InitializeKeyStates();

    /*
       The function below are called when the respective event
       is triggered. Very simple, isn't it?
    */
    //glutReshapeFunc(glutResize);		// called every time  the screen is resized
    //glutDisplayFunc(glutDisplay);		// called when window needs to be redisplayed
    //glutIdleFunc(myGlutIdle);			// called whenever the application is idle
    //glutKeyboardFunc(glutKeyboard);		// called when the application receives a input from the keyboard
	glutKeyboardUpFunc(glutKeyboardUp);	//jal
    //glutMouseFunc(glutMouse);			// called when the application receives a input from the mouse
    glutMotionFunc(glutMotion);			// called when the mouse moves over the screen with one of this button pressed
    //glutSpecialFunc(glutSpecial);		// called when a special key is pressed like SHIFT
	glutSpecialUpFunc(glutSpecialUp);	//jal

    /*
        Do any lighting, material, alpha, etc initialization or
        configuration here.
    */

    InitializeOGL();

    /*
        Creates a menu attached to the mouses middle button
        the menu here consists in two options, one to toggle
        fullscreen mode and another for exiting the application.
    */

#ifdef LOADMENU
    //submenu Load
    submenu_load = glutCreateMenu(loadmenu);
    dirp = opendir(LOADMENU_DATA_DIR);
    if (!dirp) {
		fprintf(stderr, "%s: can't open data directory.\n", argv[0]);
    } else {
		while ((direntp = readdir(dirp)) != NULL) {
			if (strstr(direntp->d_name, LOADMENU_EXTENSION)) {
				entries++;
				glutAddMenuEntry(direntp->d_name, -entries);
			}
		}
		closedir(dirp);

		//no file found
		if(entries == 0) {
			char scratch[32];
			sprintf(scratch, "No %s files found", LOADMENU_EXTENSION);
			glutAddMenuEntry(scratch, 0);
		}
    }
#endif //LOADMENU

	//submenu Display
	submenu = glutCreateMenu(displaySubMenu);
	glutAddMenuEntry("Show FPS", 1);
	glutAddMenuEntry("Wireframe", 2);
	glutAddMenuEntry("Backface Culling", 3);
	glutAddMenuEntry("Full Screen", 4);
	glutAddMenuEntry("Toogle Fly Mode", 5);
	glutAddMenuEntry("Show Quats", 6);


	//main menu
	glutCreateMenu(glutMenu);
//	glutAddMenuEntry("Bone: Select Next [RIGHT ARROW]", 1);
//	glutAddMenuEntry("Bone: Select Prev [LEFT ARROW]", 2);
//	glutAddMenuEntry("Bone: Set/unset Tag", 3);
//	glutAddMenuEntry("Bone: Rename", 4);
	glutAddMenuEntry("Model: Save SKP file", 5);
	glutAddMenuEntry("Model: Save SKM file", 6);
//	glutAddMenuEntry("Model: Rotate Skeleton", 7);
	glutAddSubMenu("Display", submenu);
#ifdef LOADMENU
	glutAddSubMenu("Load", submenu_load);
#endif //LOADMENU
	glutAddMenuEntry("Exit", 255);
	glutAttachMenu(GLUT_RIGHT_BUTTON);


	InitializeWorld();


	/*
	GLUI initalization
	*/
	
	//GLUI_InitRotatePanel();
	GLUI_InitGenericPanel();

	/****** Bones sub-window ******/
	show_bonepanel = 1;
	show_meshpanel = 1;
	//GLUI_InitBonePanel();
	//GLUI_InitMeshPanel();
	UpdateSharedBarPanel("Bone");

	

	//GLUI_InitRotatePanel();


	//GLUI_InitGenericPanel();
	//----------- subwindow 3---DISPLAY------------------
	

	



	glutDisplayFunc(glutDisplay);
	glutIdleFunc(NULL);
	
	//--------------------------------------------------
	// We register the idle callback with GLUI, *not* with GLUT 
	GLUI_Master.set_glutIdleFunc( GLUI_Idle );
	GLUI_Master.set_glutReshapeFunc( GLUI_Resize );
	GLUI_Master.set_glutKeyboardFunc(glutKeyboard);
	GLUI_Master.set_glutMouseFunc(glutMouse);
	GLUI_Master.set_glutSpecialFunc(glutSpecial);





    /*
       Application's main loop. All the above functions
	 are called whe the respective events are triggered
    */

	glutMainLoop();

#ifdef WIN32
	timeEndPeriod( 1 );
#endif
	return 0;
}



