/***********************************************
*
*
*
************************************************
*
* Glut Version: 3.7
*
* Very special thanks to all people who
* contributed with any online tutors or
* help files. Keep coding!
*
***********************************************/
#include <windows.h>
#include "glut.h"
#include <stdio.h>

#include "gl_scene.h"


/* creates a enum type for mouse buttons */
enum {
    BUTTON_LEFT = 0,
    BUTTON_RIGHT,
	BUTTON_MIDDLE,
    CTRL_AND_BUTTON_LEFT,
};


/* set global variables */
int mButton = -1;
int mOldY, mOldX;


/* display options */
extern int wireframe;	//externified
extern int show_fps;	//externified
extern int show_quats;
BOOL is_fullscreen = FALSE;


//-----------------------------
//
//	KEYS
//
//-----------------------------

static BOOL KeyState[256];
static BOOL SpKeyState[256];


void KEYS_InitializeKeyStates(void)
{
	int i;
	for (i=0; i<256; i++){
		KeyState[i] = FALSE;
		SpKeyState[i] = FALSE;
	}
}

//-------------------------
// keyboard inputs (make them act when pressed)
//-------------------------
void KEYS_CheckKeyStates(void)
{
	if( KeyState['w'] == TRUE || KeyState['W'] == TRUE || SpKeyState[GLUT_KEY_UP] == TRUE )
		CamMoveFwrd(1.0f);

	if( KeyState['s'] == TRUE || KeyState['S'] == TRUE || SpKeyState[GLUT_KEY_DOWN] == TRUE )
		CamMoveBack(1.0f);

	if( KeyState['a'] == TRUE || KeyState['A'] == TRUE || SpKeyState[GLUT_KEY_LEFT] == TRUE  )
		CamMoveLeft(1.0f);

	if( KeyState['d'] == TRUE || KeyState['D'] == TRUE || SpKeyState[GLUT_KEY_RIGHT] == TRUE )
		CamMoveRight(1.0f);
}

//-------------------------
// keyboard inputs (press)
//-------------------------
void KEYS_PressKey(unsigned char key, int x, int y)
{
	KeyState[key] = TRUE;
	glutPostRedisplay();
}

//--------------------------
// keyboard inputs (release)
//--------------------------
void KEYS_ReleaseKey(unsigned char key, int x, int y)
{
	KeyState[key] = FALSE;

	if(InputStringKey(key)){
		glutPostRedisplay();
		return;
	}

	if(SKM_BoneKeysAction(key)){
		glutPostRedisplay();
		return;
	}

	//KeyState[key] = FALSE;
	glutPostRedisplay();
}

//---------------------------
// special keyboard inputs (press) (SHIFT, CTRL, ALT)
//---------------------------
void KEYS_PressSpecialKey(int value, int x, int y)
{
	SpKeyState[value] = TRUE;

	glutPostRedisplay();
}


//---------------------------
// special keyboard inputs (release) (SHIFT, CTRL, ALT)
//---------------------------
void KEYS_ReleaseSpecialKey(int value, int x, int y)
{
	if(InputStringKey( (unsigned char)value ))
		return;

	SpKeyState[value] = FALSE;
	glutPostRedisplay();
}


//---------------------------
//
//	Mouse
//
//---------------------------
//----------------------------
// Moves the screen based on mouse
//----------------------------
void MOUSE_Motion(int x, int y)
{
	float sensitivity = 1.0f;

    if (mButton == BUTTON_LEFT)
    {
		if(!cam.flyMode)
			CamRotateScreen(-(mOldX - x) * sensitivity, -(mOldY - y) * sensitivity);
		else {
			CamRotateYaw((mOldX - x) * sensitivity * 0.2f);
			CamRotatePitch(-((mOldY - y) * sensitivity * 0.2f));
		}
    }
	else if (mButton == BUTTON_MIDDLE)
    {
		if (!cam.flyMode)
			CamTranslateZ( -((mOldY - y) * 0.2f * sensitivity));
    } 
    else if (mButton == CTRL_AND_BUTTON_LEFT)
    {
		if(!cam.flyMode)
			CamTranslateXY((mOldX - x) * 0.5f * sensitivity, -((mOldY - y) * 0.5f * sensitivity));
		else {
			CamMoveLeft((mOldX - x) * sensitivity * 0.5f);
			CamMoveUp((mOldY - y) * sensitivity * 0.5f);
		}
    }

    mOldX = x;
    mOldY = y;
}

//-----------------------------
// Function that handles mouse buttons input
//-----------------------------
void MOUSE_Button(int button, int state, int x, int y)
{
	if(state == GLUT_DOWN)
    {
        mOldX = x;
        mOldY = y;
        switch(button)
        {
            case GLUT_LEFT_BUTTON:
                if (glutGetModifiers() == GLUT_ACTIVE_CTRL)
                {
                   mButton = CTRL_AND_BUTTON_LEFT;
                   break;
                } else
                {
                   mButton = BUTTON_LEFT;
                   break;
                }
            case GLUT_RIGHT_BUTTON:
                mButton = BUTTON_RIGHT;
                break;

			case GLUT_MIDDLE_BUTTON:
				mButton = BUTTON_MIDDLE;
				break;
        }
    } else if (state == GLUT_UP)
      mButton = -1;
}

